#pragma once

// STD/STL
#include <memory>

// BaseClass
#include "../Converter.h"

// ArmarX
#include <RobotAPI/libraries/aron/core/data/variant/complex/NDArray.h>

namespace armarx::armem::server::ltm
{
    class ImageConverter : public Converter
    {
    public:
        ImageConverter(const ConverterType t, const std::string& s):
            Converter(t, s, aron::type::Descriptor::eImage)
        {}

        virtual ~ImageConverter() = default;

        std::vector<unsigned char> convert(const aron::data::VariantPtr& data) final;
        aron::data::VariantPtr convert(const std::vector<unsigned char>& data) final;

    protected:
        virtual std::vector<unsigned char> _convert(const aron::data::NDArrayPtr& data) = 0;
        virtual aron::data::NDArrayPtr _convert(const std::vector<unsigned char>& data) = 0;
    };
}
