#pragma once

// STD/STL
#include <memory>

// BaseClass
#include "../Converter.h"

// ArmarX
#include <RobotAPI/libraries/aron/core/data/variant/container/Dict.h>

namespace armarx::armem::server::ltm
{
    class ObjectConverter : public Converter
    {
    public:
        ObjectConverter(const ConverterType t, const std::string& s):
            Converter(t, s, aron::type::Descriptor::eObject)
        {}

        virtual ~ObjectConverter() = default;

        std::vector<unsigned char> convert(const aron::data::VariantPtr& data) final;
        aron::data::VariantPtr convert(const std::vector<unsigned char>& data) final;

    protected:
        virtual std::vector<unsigned char> _convert(const aron::data::DictPtr& data) = 0;
        virtual aron::data::DictPtr _convert(const std::vector<unsigned char>& data) = 0;
    };
}
