#pragma once

#include <filesystem>

// Base Class
#include "../base/detail/EntitySnapshotBase.h"
#include "detail/DiskStorage.h"

namespace armarx::armem::server::ltm::disk
{

    class EntitySnapshot :
            public EntitySnapshotBase,
            public DiskMemoryItem
    {
    public:
        EntitySnapshot(const std::filesystem::path& parentPath, const MemoryID& parentID, const Time& ts, const std::shared_ptr<Processors>& p);

    protected:
        void _loadAllReferences(armem::wm::EntitySnapshot&) const override;
        void _resolve(armem::wm::EntitySnapshot&) const override;
        void _store(const armem::wm::EntitySnapshot&) const override;
    };

} // namespace armarx::armem::server::ltm::disk
