#include "NLohmannJSONConverter.h"

namespace armarx::aron::converter
{
    nlohmann::json AronNlohmannJSONConverter::ConvertToNlohmannJSON(const data::VariantPtr& aron)
    {
        nlohmann::json j;
        ConvertToNlohmannJSON(aron, j);
        return j;
    }

    void AronNlohmannJSONConverter::ConvertToNlohmannJSON(const aron::data::VariantPtr& aron, nlohmann::json& j)
    {
        aron::data::writer::NlohmannJSONWriter dataWriter;
        j = aron::data::readAndWrite<DataVariant2NlohmannJSONConverterHelper>(aron);
    }

    nlohmann::json AronNlohmannJSONConverter::ConvertToNlohmannJSON(const type::VariantPtr& aron)
    {
        nlohmann::json j;
        ConvertToNlohmannJSON(aron, j);
        return j;
    }

    void AronNlohmannJSONConverter::ConvertToNlohmannJSON(const aron::type::VariantPtr& aron, nlohmann::json& j)
    {
        aron::type::writer::NlohmannJSONWriter typeWriter;
        j = aron::type::readAndWrite<TypeVariant2NlohmannJSONConverterHelper>(aron);
    }

    data::DictPtr AronNlohmannJSONConverter::ConvertFromNlohmannJSONObject(const nlohmann::json& j)
    {
        // TODO Switch case over json type and add other methods, e.g. for float, array, ...
        // TODO add check if json is object_t
        data::VariantPtr aron = std::make_shared<aron::data::Dict>();
        ConvertFromNlohmannJSON(aron, j);
        return data::Dict::DynamicCastAndCheck(aron);
    }

    void AronNlohmannJSONConverter::ConvertFromNlohmannJSON(aron::data::VariantPtr& a, const nlohmann::json& e, const aron::type::VariantPtr& expectedStructure)
    {
        aron::data::writer::NlohmannJSONWriter dataWriter;
        a = aron::data::readAndWrite<NlohmannJSON2DataVariantConverterHelper>(e);
    }
}
