#pragma once

#include "Skill.h"

#include <RobotAPI/libraries/aron/core/type/variant/container/Object.h>

// Debug
#include <RobotAPI/libraries/aron/converter/json/NLohmannJSONConverter.h>

namespace armarx
{
    namespace skills
    {
        template <class AronT>
        class SpecializedSkill : public Skill
        {
        public:
            using Skill::Skill;
            virtual ~SpecializedSkill() = default;

            /// returns the accepted type of the skill
            static armarx::aron::type::ObjectPtr GetAcceptedType()
            {
                return AronT::ToAronType();
            }

            /// Override this method with the actual implementation. The callback is for status updates to the calling instance
            virtual Status execute(const AronT& params, const CallbackT& callback = [](const aron::data::DictPtr& returnValue) { (void) returnValue; })
            {
                (void) params;
                return Status::Succeeded;
            }

            virtual void init(const AronT& params)
            {
                (void) params;
            }

            virtual void exit(const AronT& params)
            {
                (void) params;
            }

            Status initExecuteExit(const AronT& params, const CallbackT& callback = [](const aron::data::DictPtr& returnValue) { (void) returnValue; })
            {
                return Skill::initExecuteExit(params.toAron(), callback);
            }

            /// Do not use anymore
            Status execute(const aron::data::DictPtr& params, const CallbackT& callback = [](const aron::data::DictPtr& returnValue) { (void) returnValue; }) final
            {
                Skill::execute(params, callback);
                AronT p;
                p.fromAron(params);

                return execute(p, callback);
            }

            /// Do not use anymore
            void init(const aron::data::DictPtr& params) final
            {
                Skill::init(params);
                AronT p;
                //ARMARX_IMPORTANT << aron::converter::AronNlohmannJSONConverter::ConvertToNlohmannJSON(params).dump(2);
                p.fromAron(params);

                return init(p);
            }

            /// Do not use anymore
            void exit(const aron::data::DictPtr& params) final
            {
                Skill::exit(params);
                AronT p;
                p.fromAron(params);

                exit(p);
            }
        };
    }
}
